Attribute VB_Name = "modEncryption"
Declare Sub SSInit Lib "sasme" (SSEncrTable As SStable)
Declare Function SSEncrypt Lib "sasme" (SSEncrTable As SStable, StrToEncr As String, ByVal StartPos As Integer) As Long
Declare Function SSDecrypt Lib "sasme" (SSEncrTable As SStable, StrToDecr As String, ByVal StartPos As Integer) As Long
Declare Function SSPingValue Lib "sasme" () As Long
Declare Sub SSRandomize Lib "sasme" (ByVal Seed As Long)
Declare Function SSRnd Lib "sasme" () As Integer
Declare Function SSKey01 Lib "sasme" () As Long
Declare Function SSProc1 Lib "sasme" () As Long
Declare Sub SSProc2 Lib "sasme" (Packet03 As String)

Type SStable
 SSKey As Long
 SSBuf(1 To 520) As Byte
End Type

Public SSEncrTable As SStable
Public SSEncrKey As Long

Sub InitEncryption(key As Long)
Dim I As Integer

SSEncrKey = key Xor SSEncrKey 'Used only for comparison below.
For I = 1 To 520
 SSEncrTable.SSBuf(I) = 0
Next
SSEncrTable.SSKey = key
SSInit SSEncrTable
End Sub

Sub Encrypt(packet As String)
If SSEncrKey = 0 Then Exit Sub

If Left(packet, 1) = Chr(0) Then
 SSEncrypt SSEncrTable, packet, 3
Else
 SSEncrypt SSEncrTable, packet, 2
End If
End Sub

Sub Decrypt(packet As String)
If SSEncrKey = 0 Then Exit Sub

If Left(packet, 1) = Chr(0) Then
 SSDecrypt SSEncrTable, packet, 3
Else
 SSDecrypt SSEncrTable, packet, 2
End If
End Sub
